//+------------------------------------------------------------------+
//|                                                       Range.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Oleg Tsarkov"
#property link      "OlegTsarkov@yandex.ru"

//---- input parameters
extern int       MAFast=50; //      
extern int       IndFast=1; //  (   TrendPMZ)  
extern int       TFFast=PERIOD_M1; //  
extern int       MASlow=50; //      
extern int       IndSlow=1; //  (   TrendPMZ)
extern int       TFSlow=PERIOD_H1; //  
extern double    BasePoint=1.2; //    buy
extern double    BasePointHighLevel=1.6; //    buy
extern int       Shift=100; //   sell
extern int       TProf=460; //,     (  - 0)
extern int       Step=500;  // 
extern int       TrATR1=5;  // ATR    
extern int       TrATR2=36;
extern bool      TrailYN=false; //   
extern int       TrendUpDn=0; //"1"-  buy,"-1"- sell,"0"-
extern int       OnlyFastSlow=0; //0-   , 1- , 2- , 3-  
extern double    BaseLot=0.01;
extern int       _MM=0; //, 0-    , 1-  , 2-     


bool Work=true;                    //   .
int  Ticket; //  
double CurLot;
string Komment="RangeX"; //  ,    "-"                         


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //  -----------------------------------------------------------------------
   CurLot=LotSize();

   // ------------------------------------------------------------------------
   int i;
   if (TrailYN==true)
   {
   for(i=1; i<=OrdersTotal(); i++)          //   
      {
         if (OrderSelect(i-1,SELECT_BY_POS)==true)
            {
               if (OrderSymbol()!=Symbol())continue; //  
               if (OrderType()!=OP_BUY && OrderType()!=OP_SELL) continue; //  
               if (StringSubstr(OrderComment(),0,6)!=Komment)continue; //   
               TrailingByATR(OrderTicket(),60,TrATR1,1,TrATR2,1,1,false);
               
            }   
      }   
   }
   // -------------------------------------------------------------------------            
   
   int MindFast=TrendPMZ(MAFast,TFFast,1); //     
   int MindSlow=TrendPMZ(MASlow,TFSlow,1); //     
   int MindRez=0;
   if (OnlyFastSlow==0)
      {
      if (TrendUpDn==0)
         {
            if (MindFast==1&&MindSlow==1) MindRez=1;
            if (MindFast==-1&&MindSlow==-1) MindRez=-1;
         }
      if (TrendUpDn==1)
         {
            if (MindFast==1&&MindSlow==1) MindRez=1;
         }
      if (TrendUpDn==-1)
         {
            if (MindFast==-1&&MindSlow==-1) MindRez=-1;
         }
      }   
   if (OnlyFastSlow==1)
      {
      if (TrendUpDn==0)
         {
            if (MindFast==1) MindRez=1;
            if (MindFast==-1) MindRez=-1;
         }
      if (TrendUpDn==1)
         {
            if (MindFast==1) MindRez=1;
         }
      if (TrendUpDn==-1)
         {
            if (MindFast==-1) MindRez=-1;
         }
      }   
   if (OnlyFastSlow==2)
      {
      if (TrendUpDn==0)
         {
            if (MindSlow==1) MindRez=1;
            if (MindSlow==-1) MindRez=-1;
         }
      if (TrendUpDn==1)
         {
            if (MindSlow==1) MindRez=1;
         }
      if (TrendUpDn==-1)
         {
            if (MindSlow==-1) MindRez=-1;
         }
      }   
   if (OnlyFastSlow==3)
      {
         MindRez=TrendUpDn;
      }   
   LimOrdServ(MindRez);
//----
   return(0);
  }
//+------------------------------------------------------------------+

int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//----------------------------------------------------------------------
//  ,  :
//http://forexsystems.ru/yazyk-programmirovaniya-mql4/8599-biblioteka-funkcii-dlya-treilinga-trailingall.html
// 
void TrailingByATR(int ticket,int atr_timeframe,int atr1_period,int atr1_shift,int atr2_period,int atr2_shift,double coeff,bool trlinloss)
   {
      
   //   
   //Print("ticket: ",ticket,", atr1_period: ",atr1_period,", atr2_period: ",atr2_period,", coeff: ",coeff,", OrderSelect(ticket,SELECT_BY_TICKET): ",OrderSelect(ticket,SELECT_BY_TICKET),", atr_timeframe: ",atr_timeframe,", atr1_shift: ",atr1_shift,", atr2_shift: ",atr2_shift);
   if ((ticket==0) || (atr1_period<1) || (atr2_period<1) || (coeff==0) || (coeff<0) || (!OrderSelect(ticket,SELECT_BY_TICKET)) || 
   ((atr_timeframe!=1) && (atr_timeframe!=5) && (atr_timeframe!=15) && (atr_timeframe!=30) && (atr_timeframe!=60) && 
   (atr_timeframe!=240) && (atr_timeframe!=1440) && (atr_timeframe!=10080) && (atr_timeframe!=43200)) || (atr1_shift<0) || (atr2_shift<0))
      {
      Print("  TrailingByATR()  -     .");
      return(0);
      }
   
   double curr_atr1; //   ATR - 1
   double curr_atr2; //   ATR - 2
   double best_atr; //    ATR
   double atrXcoeff; //     ATR  
   double newstop; //  
   
   //   ATR-1, ATR-2
   curr_atr1 = iATR(Symbol(),atr_timeframe,atr1_period,atr1_shift);
   curr_atr2 = iATR(Symbol(),atr_timeframe,atr2_period,atr2_shift);
   
   //   
   best_atr = MathMax(curr_atr1,curr_atr2);
   
   //    
   atrXcoeff = best_atr * coeff;
              
   //    (OP_BUY)
   if (OrderType()==OP_BUY)
      {
      //     ( )
      newstop = Bid - atrXcoeff;
      
      //  trlinloss==true (..     ), 
      if (trlinloss==true)
         {
         // ,      ,  ,   
         if (newstop>OrderStopLoss())
         OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration());      
         }
      else
         {
         Print("Bid: ",Bid,", atrXcoeff: ",atrXcoeff,", newstop: ",newstop);
         //     ,      ( )
         if ((newstop>OrderStopLoss()) && (newstop>OrderOpenPrice()))
         OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration());         
         }
      }
      
   //    (OP_SELL)
   if (OrderType()==OP_SELL)
      {
      //     ( )
      newstop = Ask + (atrXcoeff + MarketInfo(Symbol(),MODE_SPREAD)*Point);
      
      //  trlinloss==true (..     ), 
      if (trlinloss==true)      
         {
         //   ,     
         if (OrderStopLoss()==0)
         OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()); 
         //       ,       
         else
            {
            if (newstop<OrderStopLoss())
            OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()); 
            }
         }
      else
         {
         //   ,  ,    
         if ((OrderStopLoss()==0) && (newstop<OrderOpenPrice()-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
         OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()); 
         //     0,   ,       
         else
            {
            if ((newstop<OrderStopLoss()) && (newstop<OrderOpenPrice()-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()); 
            }
         }
      }      
   }

//-----------------------------------------------------------------------------------------------
void LimOrdServ(int OrdType) //OrdType=0- ,1- -,-1-   
   {
       //    
       for(int i=1; i<=OrdersTotal(); i++)          //   
            {
               if (OrderSelect(i-1,SELECT_BY_POS)==true)
                  {
                     if (OrderSymbol()!=Symbol())continue; //   . 
                     if (OrderType()==OP_BUY||OrderType()==OP_SELL) continue;//  
                     if (StringSubstr(OrderComment(),0,6)!=Komment)continue; //   
                     if (OrdType==0) DelLimitOrd(OrderTicket());// 
                     if (OrderType()==OP_SELLLIMIT&&OrdType==1) DelLimitOrd(OrderTicket());//  
                     if (OrderType()==OP_BUYLIMIT&&OrdType==-1) DelLimitOrd(OrderTicket());//  
                     if (OrdNetValidate(OrderTicket(),OrdType)!=true) DelLimitOrd(OrderTicket());//   
                     if (OrdPriceValidate(OrderTicket(),OrdType)!=true)DelLimitOrd(OrderTicket());//  .
                  }
            }
       //   
       OrdSetUp(OrdType);//          
       OrdSetDn(OrdType);//        
     
   }
//-----------------------------------------------------------------------------------------------
void DelLimitOrd(int OrdTicket) //    
   {
        bool Ans;
        if (OrdTicket==0) return;
        while (true)
         {
         Alert("    ",OrdTicket,".  ..");
         RefreshRates();                        //  
         Alert("  ",OrdTicket);
         Ans=OrderDelete(OrdTicket);      
         if (Ans==true)                         //  :)
           {
            Alert ("   ",OrdTicket);
            Sleep(60000);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
         }
   } 
//-----------------------------------------------------------------------------------------------
bool OrdNetValidate(int OrdTicket,int OrdType) //      
   {
      double CurPrice;
      double x;
      if (OrderSelect(OrdTicket,SELECT_BY_TICKET)==true)
         {
            CurPrice=OrderOpenPrice();
            if (OrdType==1) //  buy
               {
                  for (x=BasePoint;x<BasePointHighLevel;x=x+Step*Point)
                     {
                        if (NormalizeDouble(x,Digits)==NormalizeDouble(CurPrice,Digits)) return(true);
                     }
               }
            if (OrdType==-1) //  sell
               {
                  for (x=BasePoint-Shift*Point;x<BasePointHighLevel;x=x+Step*Point)
                     {
                        if (NormalizeDouble(x,Digits)==NormalizeDouble(CurPrice,Digits)) return(true);
                     }
               }
            
         }
      
      return(false);
   }   
//-----------------------------------------------------------------------------------------------
bool OrdPriceValidate(int OrdTicket,int OrdType)//,       
   {
      double CurPrice;
      if (OrderSelect(OrdTicket,SELECT_BY_TICKET)==true)
         {
            CurPrice=OrderOpenPrice();
            if (OrdType==1) //  buy
               {
                  if (CurPrice<Bid&&CurPrice+Step*Point>Bid) return(true);
                  if (CurPrice>Bid&&CurPrice-Step*Point<Bid) return(true);
               }
            if (OrdType==-1) //  sell
               {
                  if (CurPrice<Ask&&CurPrice+Step*Point>Ask) return(true);
                  if (CurPrice>Ask&&CurPrice-Step*Point<Ask) return(true);
               }
            
         }
      
      return(false);
   }
//-----------------------------------------------------------------------------------------------
  //  
  int OpenOrder(int Ticket,int OperType,double Lots,double CurPrice,double TakeProf,string Komment)
   {
      double TP;
      while(true)
      {      
         if (OperType==0)
         {
            if (TakeProf!=0) 
               {
                  TP=Ask + New_Stop(TakeProf)*Point;
                  //TP=0;
               }
            else TP=0;   
            Alert("   buy.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
         if (OperType==1)
         {
            if (TakeProf!=0) 
               {
                  TP=Ask - New_Stop(TakeProf)*Point;
                  //TP=0;
               }
            else TP=0;   
            
            Alert("   sell.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
         if (OperType==2)  //OP_BUYLIMIT
         {
            if (TakeProf!=0) 
               {
                  TP=CurPrice + New_Stop(TakeProf)*Point;
               }
            else TP=0;   
            Alert("    BUYLIMIT.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
         if (OperType==3)  //OP_SELLLIMIT
         {
            if (TakeProf!=0) 
               {
                  TP=CurPrice - New_Stop(TakeProf)*Point;
               }
            else TP=0;   
            Alert("    SELLLIMIT.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
         if (OperType==5)  //OP_SELLSTOP
         {
            if (TakeProf!=0) 
               {
                  TP=CurPrice - New_Stop(TakeProf)*Point;
               }
            else TP=0;   
            Alert("    SELLSTOP.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
         if (OperType==4)  //OP_BUYSTOP
         {
            if (TakeProf!=0) 
               {
            TP=CurPrice + New_Stop(TakeProf)*Point;
               }
            else TP=0;   
            Alert("    BUYSTOP.  ..");
            Ticket=OrderSend(Symbol(),OperType,Lots,CurPrice,3,0,TP,Komment);// 
            if (Ticket > 0)                        //  :)
            {
               Alert ("   :"+CurPrice,Ticket);
               return(1);                             //   
            }
            if (Fun_Error(GetLastError())==1)      //  
               continue;                           //  
            return(0);
         }                                //   
      }

   }

//-----------------------------------------------------------------------------------------------
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }

//-----------------------------------------------------------------------------------------------
//      
bool OrdExist(double CurPrice) 
   {
   bool LimitOrd=false;
   for(int i=1; i<=OrdersTotal(); i++)          //   
      {
         if (OrderSelect(i-1,SELECT_BY_POS)==true)
            {
               if (OrderSymbol()!=Symbol())continue; //   . 
               if (StringSubstr(OrderComment(),0,6)!=Komment)continue; //   
               //if (OrderType()==OP_SELLLIMIT||OrderType()==OP_SELLSTOP||OrderType()==OP_BUYLIMIT||OrderType()==OP_BUYSTOP)
               //   {LimitOrd=true;} else {LimitOrd=false;}
               if (NormalizeDouble(OrderOpenPrice(),Digits)==NormalizeDouble(CurPrice,Digits)) return(true);
            }
      }
   return(false);   
   }
//-----------------------------------------------------------------------------------------------
void OrdSetUp(int OrdType)//        
   {
   double CurPrice;
   double x;
   for(int i=1; i<=OrdersTotal(); i++)          //   
      {
         if (OrderSelect(i-1,SELECT_BY_POS)==true)
            {
                 CurPrice=OrderOpenPrice();
                 if (OrdType==1)
                  {
                     if (CurPrice>Bid&&CurPrice-Step*Point<Bid) return;
                  }
                 if (OrdType==-1)
                  {
                     if (CurPrice>Ask&&CurPrice-Step*Point<Ask) return;
                  }
            
            }

      }
   if (OrdType==1)
      {
         for (x=BasePoint;x<BasePointHighLevel;x=x+Step*Point)
            {
               if (x>Bid&&OrdExist(x)==false) 
                  {OpenOrder(Ticket,OP_BUYSTOP,CurLot,x,TProf,Komment); return;}
            }
      }
   if (OrdType==-1)
      {
         for (x=BasePoint-Shift*Point;x<BasePointHighLevel;x=x+Step*Point)
            {
               if (x>Ask&&OrdExist(x)==false) 
                  {}//{OpenOrder(Ticket,OP_SELLLIMIT,CurLot,x,TProf,Komment); return;}
            }
      }
   }
void OrdSetDn(int OrdType)//        
   {
   double CurPrice;
   double x;
   for(int i=1; i<=OrdersTotal(); i++)          //   
      {
         if (OrderSelect(i-1,SELECT_BY_POS)==true)
            {
                 CurPrice=OrderOpenPrice();
                 if (OrdType==1)
                  {
                     if (CurPrice<Bid&&CurPrice+Step*Point>Bid) return;
                  }
                 if (OrdType==-1)
                  {
                     if (CurPrice<Ask&&CurPrice+Step*Point>Ask) return;
                  }
            
            }

      }
   if (OrdType==1)
      {
         for (x=BasePoint;x<BasePointHighLevel;x=x+Step*Point)
            {
               if (x<Bid&&x+Step*Point>Bid&&OrdExist(x)==false) 
                  {}//{OpenOrder(Ticket,OP_BUYLIMIT,CurLot,x,TProf,Komment); return;}
            }
      }
   if (OrdType==-1)
      {
         for (x=BasePoint-Shift*Point;x<BasePointHighLevel;x=x+Step*Point)
            {
               if (x<Ask&&x+Step*Point>Ask&&OrdExist(x)==false) 
                  {OpenOrder(Ticket,OP_SELLSTOP,CurLot,x,TProf,Komment); return;}
            }
      }
   
   }
   //     http://articles.mql4.com/ru/601
   double LotSize() 
   {
   double size;
   double lot;
   switch( _MM )
   {
      case 0:  size = BaseLot;  
               break;
      case 1:  size = BaseLot * AccountBalance() / 1000; 
               break;
      case 2:  size = BaseLot * MathSqrt( AccountBalance() / 1000 ); 
               //size = 1. * MathSqrt( AccountBalance() / 10000 ); 
               break;
      default: size = BaseLot;  break;
   }  
   if( size < BaseLot )          //      BaseLot ?
      if( ( AccountFreeMarginCheck( Symbol(), OP_BUY,  BaseLot ) < 10. ) || 
          ( AccountFreeMarginCheck( Symbol(), OP_SELL, BaseLot ) < 10. ) || 
          ( GetLastError() == 134 ) )
                  lot = 0.0; // ,  
      else        lot = BaseLot; // ;  0.1
   else           lot = NormalizeDouble( size, 2 ); 
   
   return( lot ); 
   }
   //    
   int TrendPMZ(int Usredn,int CurPeriod,int IndicatorType) //1-WATR, 2-CFP
      {
         if (IndicatorType==1) 
            {
               double WatrUp=iCustom(NULL,CurPeriod,"WATR",10,4,Usredn,0,1);
               double WatrDn=iCustom(NULL,CurPeriod,"WATR",10,4,Usredn,1,1);
               if (WatrUp<100000) return(1);
               if (WatrDn<100000) return(-1);
               return(0);
            }   
         if (IndicatorType==2) 
            {
               double Force=iForce(NULL,CurPeriod,Usredn,MODE_SMA,PRICE_CLOSE,1);
               if (Force>0) return(1);
               if (Force<0) return(-1);
               return(0);
            }   
      }
      
      